<configuration>
  <conversionRule conversionWord="clr" converterClass="org.springframework.boot.logging.logback.ColorConverter"/>
  <conversionRule conversionWord="wex" converterClass="org.springframework.boot.logging.logback.WhitespaceThrowableProxyConverter"/>

  <appender name="STDOUT" class="ch.qos.logback.core.ConsoleAppender">
    <encoder class="ch.qos.logback.classic.encoder.PatternLayoutEncoder">
      <charset>UTF-8</charset> 
      <pattern>
        <!--Date-->%clr(%d{yyyy-MM-dd HH:mm:ss.SSS}){faint} <!--Log level--> %clr(%5p) <!--Thread--> %clr(---){faint} %clr([%15.15t]){faint} <!--Logger-->%clr(%-40.40logger{39}){cyan} %clr(:){faint} %m%n%wex
      </pattern>
    </encoder>
  </appender>

  <if condition='isDefined("grails.util.BuildSettings.TARGET_DIR")'>
    <then>
      <appender name="FULL_STACKTRACE" class="ch.qos.logback.core.FileAppender" append="true">
        <encoder class="ch.qos.logback.classic.encoder.PatternLayoutEncoder">
          <file>${grails.util.BuildSettings.TARGET_DIR}/stacktrace.log</file> 
          <pattern>
            %level %logger - %msg%n
          </pattern>
        </encoder>
      </appender>
      <logger name="StackTrace" additivity="false">
        <level value="ERROR" />
        <appender-ref ref="FULL_STACKTRACE" />
      </logger>
    </then>
  </if>

  <root level="warn">
    <appender-ref ref="STDOUT" />
  </root>
</configuration>

<!--Original logback.groovy-->
<!--
import grails.util.BuildSettings
import grails.util.Environment
import org.springframework.boot.logging.logback.ColorConverter
import org.springframework.boot.logging.logback.WhitespaceThrowableProxyConverter

import java.nio.charset.Charset

conversionRule 'clr', ColorConverter
conversionRule 'wex', WhitespaceThrowableProxyConverter

// See http://logback.qos.ch/manual/groovy.html for details on configuration
appender('STDOUT', ConsoleAppender) {
    encoder(PatternLayoutEncoder) {
        charset = Charset.forName('UTF-8')

        pattern =
                '%clr(%d{yyyy-MM-dd HH:mm:ss.SSS}){faint} ' + // Date
                        '%clr(%5p) ' + // Log level
                        '%clr(- - -){faint} %clr([%15.15t]){faint} ' + // Thread
                        '%clr(%-40.40logger{39}){cyan} %clr(:){faint} ' + // Logger
                        '%m%n%wex' // Message
    }
}

def targetDir = BuildSettings.TARGET_DIR
if (Environment.isDevelopmentMode() && targetDir != null) {
    appender("FULL_STACKTRACE", FileAppender) {
        file = "${targetDir}/stacktrace.log"
        append = true
        encoder(PatternLayoutEncoder) {
            pattern = "%level %logger - %msg%n"
        }
    }
    logger("StackTrace", ERROR, ['FULL_STACKTRACE'], false)
}
root(ERROR, ['STDOUT'])

-->